"""autogenerated by genpy from pr2_gripper_sensor_msgs/PR2GripperEventDetectorActionGoal.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import actionlib_msgs.msg
import pr2_gripper_sensor_msgs.msg
import std_msgs.msg

class PR2GripperEventDetectorActionGoal(genpy.Message):
  _md5sum = "b1b345667b018e9030cc7b6aad5c1455"
  _type = "pr2_gripper_sensor_msgs/PR2GripperEventDetectorActionGoal"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
PR2GripperEventDetectorGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: pr2_gripper_sensor_msgs/PR2GripperEventDetectorGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Event Detector action used to tell detect events happening on the 
# palm mounted accelerometer and finger pressure sensors

#goal
PR2GripperEventDetectorCommand command

================================================================================
MSG: pr2_gripper_sensor_msgs/PR2GripperEventDetectorCommand
# state variable that defines what events we would like to trigger on
# Leaving this field blank will result in the robot triggering when 
# anything touches the sides of the finger or an impact is detected
# with the hand/arm.
int8 trigger_conditions
# definitions for our various trigger_conditions values
# trigger on either acceleration contact or finger sensor side impact
int8 FINGER_SIDE_IMPACT_OR_ACC = 0
# tigger once  both slip and acceleration signals occur
int8 SLIP_AND_ACC = 1 
#  trigger on either slip, acceleration, or finger sensor side impact
int8 FINGER_SIDE_IMPACT_OR_SLIP_OR_ACC = 2
# trigger only on slip information
int8 SLIP = 3
# trigger only on acceleration contact information
int8 ACC = 4 


# the amount of acceleration to trigger on (acceleration vector magnitude)
# Units = m/s^2
# The user needs to be concerned here about not setting the trigger too
# low so that is set off by the robot's own motions.
#
# For large rapid motions, say by a motion planner, 5 m/s^2 is a good level
# For small delicate controlled motions this can be set MUCH lower (try 2.0)
#
# NOTE: When moving the gripper joint (opening/closing the grippr)
# the high gearing of the PR2 gripper causes large acceleration vibrations
# which will cause triggering to occur. This is a known drawback of the PR2.
#
# NOTE: Leaving this value blank will result in a 0 m/s^2 trigger. If you
# are using a trigger_conditions value that returns on acceleration contact
# events then it will immediately exceed your trigger and return
float64 acceleration_trigger_magnitude


# the slip detector gain to trigger on (either finger) : try 0.01
# higher values decrease slip sensitivty (to a point)
# lower values increase sensitivity (to a point)
#
# NOTE: Leaving this value blank will result in the most sensitive slip level.
float64 slip_trigger_magnitude
"""
  __slots__ = ['header','goal_id','goal']
  _slot_types = ['std_msgs/Header','actionlib_msgs/GoalID','pr2_gripper_sensor_msgs/PR2GripperEventDetectorGoal']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,goal_id,goal

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PR2GripperEventDetectorActionGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      if self.goal is None:
        self.goal = pr2_gripper_sensor_msgs.msg.PR2GripperEventDetectorGoal()
    else:
      self.header = std_msgs.msg.Header()
      self.goal_id = actionlib_msgs.msg.GoalID()
      self.goal = pr2_gripper_sensor_msgs.msg.PR2GripperEventDetectorGoal()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.goal_id.stamp.secs, _x.goal_id.stamp.nsecs))
      _x = self.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_b2d.pack(_x.goal.command.trigger_conditions, _x.goal.command.acceleration_trigger_magnitude, _x.goal.command.slip_trigger_magnitude))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      if self.goal is None:
        self.goal = pr2_gripper_sensor_msgs.msg.PR2GripperEventDetectorGoal()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.goal_id.stamp.secs, _x.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal_id.id = str[start:end].decode('utf-8')
      else:
        self.goal_id.id = str[start:end]
      _x = self
      start = end
      end += 17
      (_x.goal.command.trigger_conditions, _x.goal.command.acceleration_trigger_magnitude, _x.goal.command.slip_trigger_magnitude,) = _struct_b2d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.goal_id.stamp.secs, _x.goal_id.stamp.nsecs))
      _x = self.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_b2d.pack(_x.goal.command.trigger_conditions, _x.goal.command.acceleration_trigger_magnitude, _x.goal.command.slip_trigger_magnitude))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      if self.goal is None:
        self.goal = pr2_gripper_sensor_msgs.msg.PR2GripperEventDetectorGoal()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.goal_id.stamp.secs, _x.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal_id.id = str[start:end].decode('utf-8')
      else:
        self.goal_id.id = str[start:end]
      _x = self
      start = end
      end += 17
      (_x.goal.command.trigger_conditions, _x.goal.command.acceleration_trigger_magnitude, _x.goal.command.slip_trigger_magnitude,) = _struct_b2d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_b2d = struct.Struct("<b2d")
_struct_2I = struct.Struct("<2I")
