"""autogenerated by genpy from pr2_gripper_sensor_msgs/PR2GripperEventDetectorFeedback.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import pr2_gripper_sensor_msgs.msg

class PR2GripperEventDetectorFeedback(genpy.Message):
  _md5sum = "817b45a51c75a067eb5dfb8e18b14aa1"
  _type = "pr2_gripper_sensor_msgs/PR2GripperEventDetectorFeedback"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# feedback
PR2GripperEventDetectorData data



================================================================================
MSG: pr2_gripper_sensor_msgs/PR2GripperEventDetectorData
# Time the data was recorded at
time stamp

# true if the trigger conditions have been met 
# (see PR2GripperEventDetectorCommand)
bool trigger_conditions_met

# true if the pressure sensors detected a slip event
# slip events occur when the finger pressure sensors
# high-freq. content exceeds the slip_trigger_magnitude variable
# (see PR2GripperEventDetectorCommand)
bool slip_event

# true if the hand-mounted accelerometer detected a contact acceleration
# acceleration events occur when the palm accelerometer
# high-freq. content exceeds the acc_trigger_magnitude variable
# (see PR2GripperEventDetectorCommand)
bool acceleration_event

# the high-freq acceleration vector that was last seen (x,y,z)
float64[3] acceleration_vector
"""
  __slots__ = ['data']
  _slot_types = ['pr2_gripper_sensor_msgs/PR2GripperEventDetectorData']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PR2GripperEventDetectorFeedback, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.data is None:
        self.data = pr2_gripper_sensor_msgs.msg.PR2GripperEventDetectorData()
    else:
      self.data = pr2_gripper_sensor_msgs.msg.PR2GripperEventDetectorData()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2I3B.pack(_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.trigger_conditions_met, _x.data.slip_event, _x.data.acceleration_event))
      buff.write(_struct_3d.pack(*self.data.acceleration_vector))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.data is None:
        self.data = pr2_gripper_sensor_msgs.msg.PR2GripperEventDetectorData()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.trigger_conditions_met, _x.data.slip_event, _x.data.acceleration_event,) = _struct_2I3B.unpack(str[start:end])
      self.data.trigger_conditions_met = bool(self.data.trigger_conditions_met)
      self.data.slip_event = bool(self.data.slip_event)
      self.data.acceleration_event = bool(self.data.acceleration_event)
      start = end
      end += 24
      self.data.acceleration_vector = _struct_3d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2I3B.pack(_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.trigger_conditions_met, _x.data.slip_event, _x.data.acceleration_event))
      buff.write(self.data.acceleration_vector.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.data is None:
        self.data = pr2_gripper_sensor_msgs.msg.PR2GripperEventDetectorData()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.data.stamp.secs, _x.data.stamp.nsecs, _x.data.trigger_conditions_met, _x.data.slip_event, _x.data.acceleration_event,) = _struct_2I3B.unpack(str[start:end])
      self.data.trigger_conditions_met = bool(self.data.trigger_conditions_met)
      self.data.slip_event = bool(self.data.slip_event)
      self.data.acceleration_event = bool(self.data.acceleration_event)
      start = end
      end += 24
      self.data.acceleration_vector = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2I3B = struct.Struct("<2I3B")
_struct_3d = struct.Struct("<3d")
