"""autogenerated by genpy from pr2_gripper_sensor_msgs/PR2GripperForceServoData.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import pr2_gripper_sensor_msgs.msg

class PR2GripperForceServoData(genpy.Message):
  _md5sum = "d3960eb2ecb6a9b4c27065619e47fd06"
  _type = "pr2_gripper_sensor_msgs/PR2GripperForceServoData"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Time the data was recorded at
time stamp

# the force experienced by the finger Pads  (N)
# NOTE:this ignores data from the edges of the finger pressure
float64 left_fingertip_pad_force
float64 right_fingertip_pad_force

# the current gripper virtual parallel joint effort (in N)
float64 joint_effort

# true when the gripper is no longer moving
# and we have reached the desired force level
bool force_achieved


# the control state of our realtime controller
PR2GripperSensorRTState rtstate

================================================================================
MSG: pr2_gripper_sensor_msgs/PR2GripperSensorRTState
# the control state of our realtime controller
int8 realtime_controller_state

# predefined values to indicate our realtime_controller_state
int8 DISABLED = 0
int8 POSITION_SERVO = 3
int8 FORCE_SERVO = 4
int8 FIND_CONTACT = 5
int8 SLIP_SERVO = 6
"""
  __slots__ = ['stamp','left_fingertip_pad_force','right_fingertip_pad_force','joint_effort','force_achieved','rtstate']
  _slot_types = ['time','float64','float64','float64','bool','pr2_gripper_sensor_msgs/PR2GripperSensorRTState']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       stamp,left_fingertip_pad_force,right_fingertip_pad_force,joint_effort,force_achieved,rtstate

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PR2GripperForceServoData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.left_fingertip_pad_force is None:
        self.left_fingertip_pad_force = 0.
      if self.right_fingertip_pad_force is None:
        self.right_fingertip_pad_force = 0.
      if self.joint_effort is None:
        self.joint_effort = 0.
      if self.force_achieved is None:
        self.force_achieved = False
      if self.rtstate is None:
        self.rtstate = pr2_gripper_sensor_msgs.msg.PR2GripperSensorRTState()
    else:
      self.stamp = genpy.Time()
      self.left_fingertip_pad_force = 0.
      self.right_fingertip_pad_force = 0.
      self.joint_effort = 0.
      self.force_achieved = False
      self.rtstate = pr2_gripper_sensor_msgs.msg.PR2GripperSensorRTState()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2I3dBb.pack(_x.stamp.secs, _x.stamp.nsecs, _x.left_fingertip_pad_force, _x.right_fingertip_pad_force, _x.joint_effort, _x.force_achieved, _x.rtstate.realtime_controller_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.rtstate is None:
        self.rtstate = pr2_gripper_sensor_msgs.msg.PR2GripperSensorRTState()
      end = 0
      _x = self
      start = end
      end += 34
      (_x.stamp.secs, _x.stamp.nsecs, _x.left_fingertip_pad_force, _x.right_fingertip_pad_force, _x.joint_effort, _x.force_achieved, _x.rtstate.realtime_controller_state,) = _struct_2I3dBb.unpack(str[start:end])
      self.force_achieved = bool(self.force_achieved)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2I3dBb.pack(_x.stamp.secs, _x.stamp.nsecs, _x.left_fingertip_pad_force, _x.right_fingertip_pad_force, _x.joint_effort, _x.force_achieved, _x.rtstate.realtime_controller_state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.rtstate is None:
        self.rtstate = pr2_gripper_sensor_msgs.msg.PR2GripperSensorRTState()
      end = 0
      _x = self
      start = end
      end += 34
      (_x.stamp.secs, _x.stamp.nsecs, _x.left_fingertip_pad_force, _x.right_fingertip_pad_force, _x.joint_effort, _x.force_achieved, _x.rtstate.realtime_controller_state,) = _struct_2I3dBb.unpack(str[start:end])
      self.force_achieved = bool(self.force_achieved)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2I3dBb = struct.Struct("<2I3dBb")
