"""autogenerated by genpy from pr2_gripper_sensor_msgs/PR2GripperReleaseGoal.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import pr2_gripper_sensor_msgs.msg

class PR2GripperReleaseGoal(genpy.Message):
  _md5sum = "f92a4c7c03d33b62ef7f6041bec6a43d"
  _type = "pr2_gripper_sensor_msgs/PR2GripperReleaseGoal"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#goal
PR2GripperReleaseCommand command

================================================================================
MSG: pr2_gripper_sensor_msgs/PR2GripperReleaseCommand
# the event conditions we would like to trigger the robot to release on
PR2GripperEventDetectorCommand event
================================================================================
MSG: pr2_gripper_sensor_msgs/PR2GripperEventDetectorCommand
# state variable that defines what events we would like to trigger on
# Leaving this field blank will result in the robot triggering when 
# anything touches the sides of the finger or an impact is detected
# with the hand/arm.
int8 trigger_conditions
# definitions for our various trigger_conditions values
# trigger on either acceleration contact or finger sensor side impact
int8 FINGER_SIDE_IMPACT_OR_ACC = 0
# tigger once  both slip and acceleration signals occur
int8 SLIP_AND_ACC = 1 
#  trigger on either slip, acceleration, or finger sensor side impact
int8 FINGER_SIDE_IMPACT_OR_SLIP_OR_ACC = 2
# trigger only on slip information
int8 SLIP = 3
# trigger only on acceleration contact information
int8 ACC = 4 


# the amount of acceleration to trigger on (acceleration vector magnitude)
# Units = m/s^2
# The user needs to be concerned here about not setting the trigger too
# low so that is set off by the robot's own motions.
#
# For large rapid motions, say by a motion planner, 5 m/s^2 is a good level
# For small delicate controlled motions this can be set MUCH lower (try 2.0)
#
# NOTE: When moving the gripper joint (opening/closing the grippr)
# the high gearing of the PR2 gripper causes large acceleration vibrations
# which will cause triggering to occur. This is a known drawback of the PR2.
#
# NOTE: Leaving this value blank will result in a 0 m/s^2 trigger. If you
# are using a trigger_conditions value that returns on acceleration contact
# events then it will immediately exceed your trigger and return
float64 acceleration_trigger_magnitude


# the slip detector gain to trigger on (either finger) : try 0.01
# higher values decrease slip sensitivty (to a point)
# lower values increase sensitivity (to a point)
#
# NOTE: Leaving this value blank will result in the most sensitive slip level.
float64 slip_trigger_magnitude
"""
  __slots__ = ['command']
  _slot_types = ['pr2_gripper_sensor_msgs/PR2GripperReleaseCommand']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       command

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PR2GripperReleaseGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.command is None:
        self.command = pr2_gripper_sensor_msgs.msg.PR2GripperReleaseCommand()
    else:
      self.command = pr2_gripper_sensor_msgs.msg.PR2GripperReleaseCommand()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_b2d.pack(_x.command.event.trigger_conditions, _x.command.event.acceleration_trigger_magnitude, _x.command.event.slip_trigger_magnitude))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.command is None:
        self.command = pr2_gripper_sensor_msgs.msg.PR2GripperReleaseCommand()
      end = 0
      _x = self
      start = end
      end += 17
      (_x.command.event.trigger_conditions, _x.command.event.acceleration_trigger_magnitude, _x.command.event.slip_trigger_magnitude,) = _struct_b2d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_b2d.pack(_x.command.event.trigger_conditions, _x.command.event.acceleration_trigger_magnitude, _x.command.event.slip_trigger_magnitude))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.command is None:
        self.command = pr2_gripper_sensor_msgs.msg.PR2GripperReleaseCommand()
      end = 0
      _x = self
      start = end
      end += 17
      (_x.command.event.trigger_conditions, _x.command.event.acceleration_trigger_magnitude, _x.command.event.slip_trigger_magnitude,) = _struct_b2d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_b2d = struct.Struct("<b2d")
